# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields,osv
from tools.translate import _


class account_invoice(osv.osv):
    
    _inherit = 'account.invoice'
    
    def validate_wh_income_done(self,cr,uid,ids,context=None):
        if context is None:
            context = {}
        invoice_obj = self.pool.get('account.invoice')
        user = self.pool.get('res.users')
        result = super(account_invoice, self).validate_wh_income_done(cr, uid, ids, context=context)
        invo_brw = invoice_obj.browse(cr,uid,ids[0],context=context)
        if context.get('type',False):
            if context['type'] == 'payment':
                if invo_brw.islr_wh_doc_id:
                    if context['company'].partner_id.islr_withholding_agent:
                        if result:
                            if [i.id for i in invoice_obj.browse(cr,uid,ids,context=context) for d in i.invoice_line if d.concept_id.withholdable ]:
                                return True
                            else:
                                raise osv.except_osv(_('Processing Error'), _('No such product is a service must have at least'))
                        else:
                            raise osv.except_osv(_('Processing Error'), _('The invoice is not a withholding document'))
                    else:
                        raise osv.except_osv(_('Processing Error'), _('The partner %s is not withholding agent') % invo_brw.partner_id.name)
          
            if context['type'] == 'receipt':
                if invo_brw.islr_wh_doc_id:
                    if invo_brw.partner_id.islr_withholding_agent:
                        if result:
                            return True
                        else:
                            raise osv.except_osv(_('Processing Error'), _('The invoice is not a withholding document'))
                    else:
                        raise osv.except_osv(_('Processing Error'), _('The partner %s is not withholding agent') % context['company'].partner_id.name )
        return result
        

account_invoice()

class account_voucher_validations(osv.osv):

    _inherit = 'account.voucher'


    def act_validations(self,cr,uid,ids,context=None):
        if context is None:
            context = {}
        result = super(account_voucher_validations,self).act_validations(cr,uid,ids,context=context)
        
        iva_obj = self.pool.get('account.invoice')
        vouch_brw = self.browse(cr,uid,ids[0],context=context)
        context.update({'type':vouch_brw.type,'company':vouch_brw.company_id})
        invoice_ids = [i.invoice_id.id for i in vouch_brw.line_ids if i.invoice_id.id]
        if invoice_ids:
            res = iva_obj.validate_wh_income_done(cr,uid,invoice_ids,context=context)
        else:
            res = True
        return res


account_voucher_validations()
    
